unit CADInspUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, InspCtrl, CompInsp, ExtCtrls,cad,TypInfo, ComCtrls,PropList;

type
  TCADInspFrm = class(TForm)
    Panel1: TPanel;
    CloseBtn: TButton;
    ComponentInspector1: TComponentInspector;
    Panel2: TPanel;
    ComponentComboBox1: TComponentComboBox;
    procedure ComponentInspector1SetValue(Sender: TObject; TheIndex: Integer; var Value: String; var EnableDefault: Boolean);
    function ComponentInspector1CallEditor(Sender: TObject;
      TheIndex: Integer; var EnableDefault: Boolean): Boolean;
    procedure ComponentInspector1GetButtonType(Sender: TObject;
      TheIndex: Integer; var Value: TButtonType);
    procedure ComponentInspector1GetEnableExternalEditor(Sender: TObject;
      TheIndex: Integer; var Value: Boolean);
    procedure ComponentComboBox1Change(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure ComponentComboBox1Filter(Sender: TObject;
      AComponent: TComponent; var EnableAdd: Boolean);
    procedure ComponentInspector1Filter(Sender: TObject; Prop: TProperty;
      var Result: Boolean);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CADInspFrm: TCADInspFrm;

implementation

{$R *.dfm}
uses MainUnit;

procedure TCADInspFrm.ComponentInspector1SetValue(Sender: TObject;
  TheIndex: Integer; var Value: String; var EnableDefault: Boolean);
begin
 Mainfrm.MyCAD1.Invalidate
end;

function TCADInspFrm.ComponentInspector1CallEditor(Sender: TObject;   TheIndex: Integer; var EnableDefault: Boolean): Boolean;
var
  OldValue: string;
begin
 Result:=False;
  with ComponentInspector1 do
  begin
    if Assigned(Properties[TheIndex]) then
      with Properties[TheIndex] do
        if TypeKind in [tkString,tkWString,tkLString] then
        begin
          EnableDefault:=False;
          OldValue:=AsString;
          AsString:=InputBox(ComponentInspector1.Instance.Name,Name,OldValue);
          Result:=AsString<>OldValue;
          if Result then Mainfrm.MyCAD1.Invalidate
        end;


  end;

end;

procedure TCADInspFrm.ComponentInspector1GetButtonType(Sender: TObject;
  TheIndex: Integer; var Value: TButtonType);
begin
exit;
  with ComponentInspector1 do
    if Assigned(Properties[TheIndex]) then
      with Properties[TheIndex] do
      if   (TypeKind in [tkString,tkWString,tkLString])and (Value=btNone) then
        Value:=btDialog;

end;

procedure TCADInspFrm.ComponentInspector1GetEnableExternalEditor(
  Sender: TObject; TheIndex: Integer; var Value: Boolean);
begin
 with ComponentInspector1 do
    if Assigned(Properties[TheIndex]) then
    begin
      with Properties[TheIndex] do

        Value:=(TypeKind in [tkString,tkWString,tkLString]) or
        (PropType=TypeInfo(TColor) )  or IsType(TypeInfo(TGraphic))
        or IsType(TypeInfo(TUserData));

    end;
end;

procedure TCADInspFrm.ComponentComboBox1Change(Sender: TObject);
begin
With   ComponentComboBox1 do
begin
if Items.Objects[ItemIndex] is TMyShape then 
MainFrm.MyCAD1.SelectShapeByCode(TMyShape(Items.Objects[ItemIndex]).GetShapeId);
end;
end;

procedure TCADInspFrm.CloseBtnClick(Sender: TObject);
begin
 close;
end;


procedure TCADInspFrm.ComponentComboBox1Filter(Sender: TObject;
  AComponent: TComponent; var EnableAdd: Boolean);
begin
 EnableAdd:=false;
   IF AComponent IS TMyCAD THEN
   BEGIN
   EnableAdd:=true;

   END;
   IF AComponent IS TMyShape THEN

   If MainFrm.MonitorParentShapesOnly THEN
    BEGIN
        If (NOT ((AComponent As  TMyShape).HasParentShape)) THEN  EnableAdd :=true;
    END
    ELSE // childshape only , add the brother shapes
    BEGIN
        If  MainFrm.MyCAD1.areTheyBrother ((AComponent As  TMyShape),MainFrm.ASelectedChildShape) THEN
        begin
         EnableAdd :=true;
         end;
    END

end;

procedure TCADInspFrm.ComponentInspector1Filter(Sender: TObject;
  Prop: TProperty; var Result: Boolean);
begin
//
end;

end.
